<?php
require __DIR__ . '/../../../init.php';

use \Illuminate\Database\Capsule\Manager as Capsule;

function joker_getSessionId($params)
{

    $c = joker_getConnection();

    $username = $params["username"];
    $password = $params["password"];


    $sessId = '';
    $response = '';

    $c->execute_request('login', [ 'username' => $username, 'password' => $password ], $response, $sessId);

    if ($response['response_header']['status-code']!=0) {
        return false;
    }

    $sessId = $response['response_header']['auth-sid'];

    // joker_log('login  after', $_SESSION['adminid'], $_SESSION['uid'], $response['response_header']['proc-id'], $response['response_header']['tracking-id'], $sessId);


    return $sessId;
}

function joker_getConnection()
{
    require_once __DIR__ . '/../../registrars/joker/lib/cls_connect.php';

    return new Connect(joker_getConfig());

}

function joker_getConfig()
{
    $config = require __DIR__ . '/../../registrars/joker/config.php';

    return $config;
}

$records = Capsule::table('mod_joker_trxlog')->select()
    ->where('status', '=', 'new')->orWhere('status', '=', 'pending')
    ->orderBy('id', 'asc')->get();

$c = joker_getConnection();
$config = joker_getConfig();
$sessId = joker_getSessionId($config);
if (!$sessId) {
    echo 'cron error: joker credential invalid';

    return;
}
foreach ($records as $item) {
    $c->execute_request('result-list', [ 'svtrid' => $item->trackid ], $response, $sessId);
    if (isset($response['response_header']['status-code'])
        && $response['response_header']['status-code']==0
        && isset($response['response_header']['row-count'])
        && $response['response_header']['row-count']==1
    ) {

        $row = explode(' ', $response['response_body']);
        if (!in_array($row[5], [ 'ack', 'nack', 'pending' ]))
            continue;


        if ($row[5]==='ack')
            $status = 'success';
        if ($row[5]==='nack')
            $status = 'failed';
        if ($row[5]==='pending')
            $status = 'pending';


        $c->execute_request('result-retrieve', [ 'svtrid' => $item->trackid ], $response, $sessId);


        if (isset($response['response_header']['status-code'])) {


            if (0!=$response['response_header']['status-code']) {
                continue;
            }

            Capsule::table('mod_joker_trxlog')
                ->where('id', $item->id)
                ->update([
                    'status' => $status,
                    'result' => $response['raw'],


                ]);


        }

    }
}


